#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <winsock.h>

int get_sv_name(char *url_string,char *result)
{
	char url[1024],server[1024];
	int i,j,pos,pos2;
	
	for (i=0;i<strlen(url_string);i++) { url[i]=tolower(url_string[i]); }// to lower case
	
	//httpT
	if ((url[0]=='h')&&(url[1]=='t')&&(url[2]=='t')&&(url[3]=='p')) {
		if (url[4]==':') {
			if (url[5]=='/') {
				if (url[6]=='/') {
					if (url[7]=='/') { pos=8; }//  "http:///" (wrong, but accept)
					else             { pos=7; }//  "http://" (correct case)
				} else {
					pos=6; //  "http:/" (wrong, but accept)
				}
			} else {
				pos=5; //  "http:" (wrong, but accept)
			}
		}  else if (url[4]=='/') {
			if (url[5]=='/') { pos=6; }//  "http//" (wrong, but accept)
			else             { pos=5; }//  "http/" (wrong, but accept)
		} else {
			pos=0; // cannot accept
		}
	} else if ((url[0]=='t')&&(url[1]=='t')&&(url[2]=='p')) {
		if (url[3]==':') {
			if (url[4]=='/') {
				if (url[5]=='/') {
					if (url[6]=='/') { pos=7; }//  "ttp:///"
					else             { pos=6; }//  "ttp://"
				} else {
					pos=5; //  "ttp:/"
				}
			} else {
				pos=4; //  "ttp:"
			}
		}  else if (url[3]=='/') {
			if (url[4]=='/') { pos=5; }//  "ttp//"
			else             { pos=4; }//  "ttp/"
		} else {
			pos=0; // cannot accept
		}
	}
	
	// get server name ("http://" is removed)
	j=0;
	for (i=pos;i<strlen(url);i++) {
		if ( url[i]=='/' ) { break; }
		result[j]=url[i]; result[j+1]='\0'; j++;
	}
	pos2=i; // end position of server name
	
	return pos2;
}

int Wget_file(char *savefile,char *request_URL)
{
	int i,l,sep,ret,soc,port,buf_len;
	WORD version;
	WSADATA wsaData;
	//char URLdata[1024];
	char svName[1024],reqPage[1024];
	char sendbuf[1024],recvbuf[1024];
	unsigned long sv_addr;
	struct hostent *host1;
	struct sockaddr_in server1;
	FILE *fp;
	
	version = MAKEWORD(1,1);
	ret = WSAStartup(version, &wsaData);
	if (ret != 0) { return -1; } // error, winsock init fail
	soc = socket(PF_INET,SOCK_STREAM,0);
	if (soc == INVALID_SOCKET) { return -1; } // error, socket init fail
	
	l=get_sv_name(request_URL,svName);
	strcpy(reqPage,request_URL+l);
	// printf("server name:%s\n",svName); printf("request page:%s\n",reqPage);
	
	// port number
	port=80;
	
	// server ip address
	sv_addr = inet_addr((char*)svName); // check svName is in format "xx.xx.xx.xx"
	if (sv_addr == -1) {
		host1 = gethostbyname(svName); // get host info from svName
		if (host1 != NULL) { sv_addr = *((unsigned long *)((host1->h_addr_list)[0])); }
	}
	if (sv_addr == -1) {
		closesocket(soc); return -1; // error, cannot get host address
	}
	
	// open server
	server1.sin_family = AF_INET;
	server1.sin_addr.s_addr = sv_addr;
	server1.sin_port = htons((unsigned short)port);
	memset(server1.sin_zero,(int)0,sizeof(server1.sin_zero));
	if (connect(soc,(struct sockaddr *)&server1,sizeof(server1))==SOCKET_ERROR) {
		closesocket(soc); return -1; // error, cannot connect
	}
	
	// send 'GET'-request
	sprintf(sendbuf,"GET %s HTTP/1.0\r\nHost: %s:%d\r\nUser-Agent: aaa/0.0\r\n\r\n",reqPage,svName,port);	/* NGXgwb_쐬 */
	if (send(soc,sendbuf,strlen(sendbuf),0) == SOCKET_ERROR){
		shutdown(soc,2); closesocket(soc); return -1; // error, cannot send req
	}
	
	// receive result (save to file)
	fp=fopen(savefile,"wb");
	if (fp==NULL) {
		shutdown(soc,2); closesocket(soc); return -1; // error, cannot create savefile
	}
	sep=0;
	while (1) {
		buf_len = recv(soc,recvbuf,1023,0);
		if (buf_len==0) { break; } // exit
		if (buf_len==SOCKET_ERROR) { break; } // error, cannot receive
		recvbuf[buf_len]='\0';
		l=0;
		if (sep==0) {
			for (i=0;i<buf_len;i++) {
				//printf("%c",recvbuf[i]);
				if ( (recvbuf[i]==0x0A)&&(recvbuf[i+1]==0x0A) ) { l=i+2; break; }
				if ( (recvbuf[i]==0x0D)&&(recvbuf[i+1]==0x0D) ) { l=i+2; break; }
				if ( (recvbuf[i]==0x0D)&&(recvbuf[i+1]==0x0A)&&(recvbuf[i+2]==0x0D)&&(recvbuf[i+3]==0x0A) ) { l=i+4; break; }
			}
			if (l>0) { sep=1; }
		}
		for (i=l;i<buf_len;i++) { fputc(recvbuf[i],fp); }
	}
	fclose(fp);
	shutdown(soc,2);
	closesocket(soc);
	WSACleanup();
	return 0;
}

int Can_I_reach_Server(char *server_name)
{
	int soc,ret,res;
	WORD version;
	WSADATA wsaData;
	struct hostent *host;

	version = MAKEWORD(1,1);
	ret = WSAStartup(version, &wsaData);
	if (ret != 0) { return -1; } // winsock init error
	soc = socket(PF_INET,SOCK_STREAM,0);
	if (soc == INVALID_SOCKET) { return -1; } // socket init errror
	
	res=0;
	host = gethostbyname(server_name);
	if (host != NULL) { res = 1; } // found
	
	closesocket(soc); 
	WSACleanup();
	return res;
}

int Get_GoogleMaps_Pict(double lat,double lng,int maptype)
{
	char URLdata[1024];
	
	if ( Can_I_reach_Server("google.com") != 1 ) {
		//printf("Google.comɐڑł܂\n"); getchar(); exit(1);
		return -1;
	}
	
	// get picture
	strcpy(URLdata,"http://maps.google.com"); // server name
	strcat(URLdata,"/staticmap"); // static map api
	sprintf(URLdata,"%s?center=%.6f,%.6f",URLdata,lat,lng); // Latitude & Longitude
	strcat(URLdata,"&hl=en"); // English
	strcat(URLdata,"&zoom=15"); // Zoom
	strcat(URLdata,"&size=600x600"); // picture size
	strcat(URLdata,"&format=png"); // picture format
	if (maptype==1) { strcat(URLdata,"&maptype=roadmap"); }  // map type1
	if (maptype==2) { strcat(URLdata,"&maptype=terrain"); }  // map type2
	if (maptype==3) { strcat(URLdata,"&maptype=satellite"); }// map type3
	if (maptype==4) { strcat(URLdata,"&maptype=hybrid"); }   // map type4
	sprintf(URLdata,"%s&markers=%.6f,%.6f,tiny",URLdata,lat,lng); // marker
	strcat(URLdata,"&sensor=false"); // use GPS
	strcat(URLdata,"&key=ABQIAAAAjRFt9Bv6w-3jDkNVarZ2QRQBqndscQNI3iRMZIMw9kPsqpX4PBQaOjGk4DBotA2E2zqz_c90TAxyEg");
	Wget_file("map_pict.png",URLdata);
	
	return 0;
}
